"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("./Button"));

var _Icon = require("./Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function CalendarHeader({
  localizer,
  label,
  labelId,
  onMoveRight,
  onMoveToday,
  onMoveLeft,
  onViewChange,
  prevDisabled,
  todayDisabled,
  upDisabled,
  nextDisabled,
  navigatePrevIcon = _Icon.chevronLeft,
  navigateNextIcon = _Icon.chevronRight,
  isRtl
}) {
  return _react.default.createElement("div", {
    className: "rw-calendar-header"
  }, _react.default.createElement(_Button.default, {
    acceptFocus: true,
    id: labelId,
    onClick: onViewChange,
    className: "rw-calendar-btn-view",
    disabled: upDisabled,
    "aria-live": "polite",
    "aria-atomic": "true"
  }, label, " ", _Icon.caretDown), _react.default.createElement(_Button.default, {
    acceptFocus: true,
    className: "rw-calendar-btn-left",
    onClick: onMoveLeft,
    disabled: prevDisabled,
    label: localizer.messages.moveBack(),
    icon: isRtl ? navigateNextIcon : navigatePrevIcon
  }), _react.default.createElement(_Button.default, {
    acceptFocus: true,
    className: "rw-calendar-btn-today",
    disabled: todayDisabled,
    onClick: onMoveToday
  }, localizer.messages.moveToday()), _react.default.createElement(_Button.default, {
    acceptFocus: true,
    className: "rw-calendar-btn-right",
    onClick: onMoveRight,
    disabled: nextDisabled,
    label: localizer.messages.moveForward(),
    icon: isRtl ? navigatePrevIcon : navigateNextIcon
  }));
}

var _default = CalendarHeader;
exports.default = _default;