"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _ListboxContext = require("./ListboxContext");

var _MultiselectTag = _interopRequireDefault(require("./MultiselectTag"));

var _dataHelpers = require("./util/dataHelpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// FIXME: just do data items
// disabled === true || [1, 2, 3, etc]
const isDisabled = (item, list, value) => !!(Array.isArray(list) ? ~(0, _dataHelpers.dataIndexOf)(list, item, value) : list);

function MultiselectTagList({
  id,
  value,
  activeId,
  dataKeyAccessor,
  textAccessor,
  label,
  disabled,
  onDelete,
  focusedItem,
  children,
  clearTagIcon,
  renderTagValue,
  tagOptionComponent: TagOption = _MultiselectTag.default
}) {
  (0, _ListboxContext.useClearListOptions)();
  return _react.default.createElement("div", {
    id: id,
    role: "listbox",
    "aria-label": label,
    className: "rw-multiselect-taglist"
  }, value.map((item, i) => {
    let isFocused = focusedItem === item;
    return _react.default.createElement(TagOption, {
      key: i,
      id: isFocused ? activeId : undefined,
      dataItem: item,
      focused: isFocused,
      onRemove: onDelete,
      clearTagIcon: clearTagIcon,
      disabled: isDisabled(item, disabled, dataKeyAccessor)
    }, renderTagValue ? renderTagValue({
      item
    }) : textAccessor(item));
  }), children);
}

var _default = MultiselectTagList;
exports.default = _default;