"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "elementType", {
  enumerable: true,
  get: function () {
    return _elementType.default;
  }
});
exports.message = exports.accessor = exports.disabled = exports.dateFormat = exports.numberFormat = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _elementType = _interopRequireDefault(require("prop-types-extra/lib/elementType"));

var _createChainableTypeChecker = _interopRequireDefault(require("prop-types-extra/lib/utils/createChainableTypeChecker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const numberFormat = (0, _createChainableTypeChecker.default)((props, ...args) => props.localizer ? props.localizer.numberPropType(props, ...args) : null);
exports.numberFormat = numberFormat;
const dateFormat = (0, _createChainableTypeChecker.default)((props, ...args) => props.localizer ? props.localizer.datePropType(props, ...args) : null);
exports.dateFormat = dateFormat;
const disabled = (0, _createChainableTypeChecker.default)((...args) => _propTypes.default.bool(...args));
exports.disabled = disabled;
disabled.acceptsArray = _propTypes.default.oneOfType([disabled, _propTypes.default.array]);

const accessor = _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]);

exports.accessor = accessor;

const message = _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.string, _propTypes.default.func]);

exports.message = message;