"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAccessors = void 0;

var _react = require("react");

var helpers = _interopRequireWildcard(require("./dataHelpers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const useAccessors = (textField, dataKey) => {
  return (0, _react.useMemo)(() => ({
    text: item => helpers.dataText(item, textField),
    value: item => helpers.dataValue(item, dataKey),
    indexOf: (data, value) => helpers.dataIndexOf(data, value, dataKey),
    matches: (a, b) => helpers.valueMatcher(a, b, dataKey),
    findOrSelf: (data, value) => helpers.dataItem(data, value, dataKey),
    includes: (data, value) => helpers.dataIndexOf(data, value, dataKey) !== -1
  }), [textField, dataKey]);
};

exports.useAccessors = useAccessors;