"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createEditableCallback = exports.isInDisabledFieldset = void 0;

var _matches = _interopRequireDefault(require("dom-helpers/matches"));

var _react = require("react");

var _useEventCallback = _interopRequireDefault(require("@restart/hooks/useEventCallback"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isInDisabledFieldset = node => {
  return !!node && (0, _matches.default)(node, 'fieldset[disabled] *');
};

exports.isInDisabledFieldset = isInDisabledFieldset;

function createCallback(disabled, ref, fn) {
  return (0, _useEventCallback.default)((...args) => {
    const inDisabledFieldset = ref.current && isInDisabledFieldset(ref.current);
    if (inDisabledFieldset || disabled == true) return;
    return fn(...args);
  });
}

const createEditableCallback = (disabled, ref) => {
  return (0, _react.useCallback)(function (fn) {
    return createCallback(disabled, ref, fn);
  }, [disabled, ref]);
};

exports.createEditableCallback = createEditableCallback;